/*
 xGL:xGLViewLite.h
 Created by mantis on 4/07/05.
 Copyright 2005 xonko interactive. All rights reserved.
 */

#import <Cocoa/Cocoa.h>

#import <Carbon/Carbon.h>
#import <OpenGL/OpenGL.h>
#import <OpenGL/gl.h>
#import <OpenGL/glu.h>
#import <OpenGL/glext.h>

#import "XGLCore.h"

#define BITS_PER_PIXEL				32.0
#define DEPTH_SIZE				32.0
#define DEFAULT_TIME_INTERVAL		0.015

@interface XGLView : NSOpenGLView 
{	
	
	NSWindow		*_startingWindow;
	NSWindow		*_fullScreenWindow;
	CGLContextObj	_contextObj;
	
	CGGammaValue redMin, redMax, redGamma,
		greenMin, greenMax, greenGamma,
		blueMin, blueMax, blueGamma ;
	
	NSTimer *_timer;
	XGLCore *_core3d;
	
	BOOL _faded;
	BOOL _suspended;
	BOOL _fullScreenMode;
	
	NSPoint _mouseDelta;
	
}

-(id)initWithFrame:(NSRect)frameRect;

-(IBAction)toggleFullScreenMode:(id)sender;
-(IBAction)toggleInspector:(id)sender;

-(void)fadeOut;
-(void)fadeIn;
-(void)render;
-(void)reshape;

- (BOOL)suspended;
- (void)setSuspended:(BOOL)value;

-(XGLCore*)core3d;

//cover methods for XGLCore

-(id)newModel;
-(id)newModelWithGeometry:(id)aGeometry;
-(id)newModelWithGeometry:(id)aGeometry andShader:(id)aShader;
-(id)newModelWithGeometry:(id)aGeometry andShader:(id)aShader andName:(id)aName;

-(id)newGeometry;
-(id)newGeometryWithType:(id)geometryType;

-(id)newParticles;

-(id)newShader;
-(id)newShaderWithDiffuse:(id)diffuseColor;
-(id)newShaderWithDiffuse:(id)diffuseColor andTexture:(id)aTexture;

-(id)newTexture;
-(id)newTextureWithImagePathOrName:(NSString *)imagePathOrName;

-(id)newLight;
-(id)newNode;

-(id)modelNamed:(NSString *)name;
-(id)lightNamed:(NSString *)name;
-(id)shaderNamed:(NSString *)name;
-(id)textureNamed:(NSString *)name;
-(id)geometryNamed:(NSString *)name;
-(id)nodeNamed:(NSString *)name;

-(id)models;
-(id)shaders;
-(id)lights;
-(id)geometries;
-(id)textures;
-(id)nodes;

-(id)sceneGraph;

-(id)camera;

@end
